//+------------------------------------------------------------------+
//|                                                     AutoGann.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int LB = 60;
extern int step = 5;

int deinit()
{
   ObjectDelete("Gann1");
   ObjectDelete("Gann2");
   return(0);
}  

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   double h_l = 0;          //highest low
   int    h_l.shift = 0;
   
   double l_l = 9999999999; //lowest  low
   int    l_l.shift = 0;
   
   double h.h = 0;          //highest high
   int    h.h.shift = 0;
   
   double l.h = 9999999999; //lowest  high
   int    l.h.shift = 0;
   
   
   double tmp = 0;
   
   //Find highest low fractal (h_l)
   for (int i = 1; i<=LB; i++)
   {
      tmp = iFractals(NULL,0,MODE_LOWER,i);
      if (tmp > h_l && tmp>0) { h_l = tmp; h_l.shift = i; }
   }   
   tmp = 0;
   
   //Find lowest low fractal (l_l) -> start from highest low fractal and work back
   l_l = h_l; // set lowest low = highest low, find lower low
   for (i = h_l.shift; i>=1; i--)
   {
      tmp = iFractals(NULL,0,MODE_LOWER,i);
      if (tmp < l_l && tmp>0) { l_l = tmp; l_l.shift = i; break;}
   } 
   tmp = 0;
   
   
   //Find lowest high fractal (l.h)
   for (i = 1; i<=LB; i++)
   {
      tmp = iFractals(NULL,0,MODE_UPPER,i);
      if (tmp < l.h && tmp>0) { l.h = tmp; l.h.shift = i; }
   }         
   tmp = 0;
   
   //Find highest high fractal(h.h)-> start from lowest high fractal and work back
   h.h = l.h; // set highest high = lowest high, find higher High
   for (i = l.h.shift; i>=1; i--)
   {
      tmp = iFractals(NULL,0,MODE_UPPER,i);
      if (tmp > h.h && tmp>0) { h.h = tmp; h.h.shift = i; break;}
   }
   tmp = 0;
   
   Print("h.h: ",h.h,"  l.h: ",l.h,"  h_l:",h_l,"  l_l:",l_l);
   
     ObjectDelete("Gann1");
     ObjectDelete("Gann2");
     
     ObjectCreate("Gann1",OBJ_GANNGRID,0,Time[h.h.shift],h.h,Time[l.h.shift],l.h);
     ObjectSet("Gann1",OBJPROP_COLOR,Blue);
     
     ObjectCreate("Gann2",OBJ_GANNGRID,0,Time[l_l.shift],l_l,Time[h_l.shift],h_l);
     ObjectSet("Gann2",OBJPROP_COLOR,Pink);
     
     ObjectSet("Gann1",OBJPROP_SCALE,-10);
     ObjectSet("Gann2",OBJPROP_SCALE,10); 
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*
void HighestLow()
{
 
   int tmp = 0;
   
    //Find highest low fractal (h_l)
   for (int i = 1; i<=LB; i++)
   {
      tmp = iFractals(NULL,0,MODE_LOWER,i);
      if (tmp > h_l && tmp>0) { h_l = tmp; h_l.shift = i; }
   }   
   tmp = 0;
   
   
    //Find lowest low fractal (l_l) -> start from highest low fractal and work back
   l_l = h_l; // set lowest low = highest low, find lower low
   for (i = h_l.shift; i<=LB; i++)
   {
      tmp = iFractals(NULL,0,MODE_LOWER,i);
      if (tmp < l_l && tmp>0) { l_l = tmp; l_l.shift = i; break;}
   } 
   tmp = 0;
   
   */